int numberObjects=200;
[DBus (name = "net.prx.test")]
public class DemoServer : Object {

	private int counterA;
	private int counterB;	
	private DBusConnection conn;
	private int id;
	
	public DemoServer(int id, DBusConnection conn){
		this.id=id;
		this.conn=conn;
		conn.register_object ("/net/prx/test/"+id.to_string(), this);
	}
	public void sendSignalA(){
		newSignalA(counterA);
		counterA++;
	}
	public void sendSignalB(){
		newSignalB(counterB);
		counterB++;
	}	

	private void newSignalA(double value){
		try {
			conn.emit_signal (null, 
			                  "/net/prx/test/"+id.to_string(), 
			                  "net.prx.test", 
			                  "newSignalA", 
			                  new Variant ("(d)",value)
			                  );
		} catch (Error e) {
			stderr.printf ("%s\n", e.message);
		}
	}
	private void newSignalB(double value){
		try {
			conn.emit_signal (null, 
			                  "/net/prx/test/"+id.to_string(), 
			                  "net.prx.test", 
			                  "newSignalB", 
			                  new Variant ("(d)",value)
			                  );
		} catch (Error e) {
			stderr.printf ("%s\n", e.message);
		}
	}	
	public void start(){
		Timeout.add (250, () => {
				sendSignalA();
				return true;
    	});	       
    		
   		Timeout.add (2000, () => {
				sendSignalB();
				return true;
    	});	          
	}
	
}


    void on_bus_acquired (DBusConnection conn) {
        print ("bus acquired\n");
        
        DemoServer []servers = new DemoServer[numberObjects];

		for (int i=0;i<numberObjects;i++){
			stdout.printf ("Creating %d\n",i);
			servers[i]= new DemoServer(i,conn);
		}
		
		for (int i=0;i<numberObjects;i++){
			stdout.printf ("Starting %d\n",i);
			servers[i].start();
		}	
    }

    void on_name_acquired () {
        print ("name acquired\n");
    }

    void on_name_lost () {
        print ("name_lost\n");
    }

int main(){
	    stdout.printf("Starting\n");
    	Bus.own_name (BusType.SYSTEM, "net.prx.genio.prx", BusNameOwnerFlags.NONE, 
                 on_bus_acquired,
                 on_name_acquired,
                 on_name_lost);   
                      
        new MainLoop ().run ();
        return 0;
    }
